SystemOrganization addCategory: #Bundleview!

RectangleMorph subclass: #GUIMainWindow
	instanceVariableNames: 'state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!GUIMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 12/25/2012 20:01'!
click
	self state ifNotNil: self state handleClick.! !

!GUIMainWindow methodsFor: 'event handling' stamp: 'CR 11/18/2012 16:01'!
handlesMouseDown: anEvent
	^true.! !

!GUIMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 12/25/2012 20:04'!
initializeState
	self state: AddNodeClickState new.! !

!GUIMainWindow methodsFor: 'event handling' stamp: 'CR 11/18/2012 16:01'!
mouseDown: anEvent
	Transcript show: 'mouse Down'.! !

!GUIMainWindow methodsFor: 'accessing' stamp: 'CR 12/25/2012 20:00'!
state
	"Answer the value of state"

	^ state! !

!GUIMainWindow methodsFor: 'accessing' stamp: 'CR 12/25/2012 20:00'!
state: anObject
	"Set the value of state"

	state := anObject! !

CircleMorph subclass: #NodeMorph
	instanceVariableNames: 'node gui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!NodeMorph methodsFor: 'accessing' stamp: 'CR 12/25/2012 19:37'!
gui
	"Answer the value of gui"

	^ gui! !

!NodeMorph methodsFor: 'accessing' stamp: 'CR 12/25/2012 19:37'!
gui: anObject
	"Set the value of gui"

	gui := anObject! !

!NodeMorph methodsFor: 'as yet unclassified' stamp: 'CR 12/25/2012 19:40'!
handlesMouseDown: anEvent
	^true.! !

!NodeMorph methodsFor: 'as yet unclassified' stamp: 'CR 12/25/2012 19:59'!
mouseDown: anEvent
	self gui ifNotNil: self gui click.! !

!NodeMorph methodsFor: 'accessing' stamp: 'CR 12/25/2012 19:37'!
node
	"Answer the value of node"

	^ node! !

!NodeMorph methodsFor: 'accessing' stamp: 'CR 12/25/2012 19:37'!
node: anObject
	"Set the value of node"

	node := anObject! !

Object subclass: #BSpline
	instanceVariableNames: 'tesselatedPoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!BSpline methodsFor: 'accessing' stamp: 'CR 10/21/2012 17:31'!
addTesselatedPoint: aPoint

	tesselatedPoints add: aPoint.! !

!BSpline methodsFor: 'rendering' stamp: 'CR 10/23/2012 14:24'!
calculateBSpline: aPointList
	
	| skm1 cpim1 cpi cpip1 sk line rkm1 lk |
	(aPointList size < 4) ifTrue: [^self].
	self addTesselatedPoint: (aPointList at: 1).
	
	skm1 := aPointList at: 1.
	cpim1 := skm1.
	cpi := aPointList at: 2.
	
	2 to: (aPointList size - 2) do: [ :i | | pointsForCurve |
		pointsForCurve := OrderedCollection new.
		(i = (aPointList size - 2))
			ifTrue: [sk := cpi.]
			ifFalse: [cpip1 := aPointList at: (i + 1).
				sk := ((cpim1 + (4 * cpi) + cpip1)/6).].
		line := cpi - cpim1.
		rkm1 := cpim1 + ((line * 1)/3).
		lk := cpim1 + ((line *2)/3).
		pointsForCurve add: skm1.
		pointsForCurve add: rkm1.
		pointsForCurve add: lk.
		pointsForCurve add: sk.
		self calculateBezier: pointsForCurve.
		skm1 := sk.
		cpim1 := cpi.
		cpi := cpip1.].! !

!BSpline methodsFor: 'rendering' stamp: 'CR 10/23/2012 14:45'!
calculateCubicBezier: aPointList
	"comment stating purpose of message"

	| bernstein0 bernstein1 bernstein2 bernstein3 calculatedPoint step stepsize t|
	stepsize := 10.
	(aPointList size = 4) ifTrue: [
		step := 1 / (stepsize - 1).
		1 to: stepsize do: [ :i |
			t := i * step.
			bernstein0 := (1 - t) * (1 - t) * (1 - t).
			bernstein1 := 3 * t * (1 - t) * (1 - t).
			bernstein2 := 3 * t * t * (1 - t).
			bernstein3 := t * t * t.
			calculatedPoint := (aPointList at: 1) * bernstein0.
			calculatedPoint := calculatedPoint + ((aPointList at: 1) * bernstein1).
			calculatedPoint := calculatedPoint + ((aPointList at: 2) * bernstein2).
			calculatedPoint := calculatedPoint + ((aPointList at: 3) * bernstein3).
			"self halt."
			self addTesselatedPoint: calculatedPoint.
		]].! !

!BSpline methodsFor: 'rendering' stamp: 'CR 10/23/2012 14:44'!
calculateQuadraticBezier: aPointList

	| bernstein0 bernstein1 bernstein2 calculatedPoint step amountOfSteps t|
	amountOfSteps := 10.
	self addTesselatedPoint: (aPointList at: 1).
	(aPointList size = 3) ifTrue: [
		step := 1 / (amountOfSteps - 1).
		2 to: amountOfSteps do: [ :i |
			t := i * step.
			bernstein0 := (1 - t) * (1 - t).
			bernstein1 := 2 * t * (1 - t).
			bernstein2 := t * t.
			calculatedPoint := (aPointList at: 1) * bernstein0.
			calculatedPoint := calculatedPoint + ((aPointList at: 2) * bernstein1).
			calculatedPoint := calculatedPoint + ((aPointList at: 3) * bernstein2).
			self addTesselatedPoint: calculatedPoint.
		]].! !

!BSpline methodsFor: 'rendering' stamp: 'CR 10/21/2012 17:37'!
drawALineFrom: aPoint To: anotherPoint
	"drawing a circle."
	| morph |
	morph := LineMorph from: aPoint to: anotherPoint color: Color black width: 2.
	morph openInWorld.! !

!BSpline methodsFor: 'initialize' stamp: 'CR 10/23/2012 14:33'!
initialize: aPointList
	"calculates the tesselatedPoints from the given control points"

	tesselatedPoints := OrderedCollection new.
	(aPointList size = 3) ifTrue: [self calculateQuadraticBezier: aPointList.] ifFalse: [Transcript show: 'calculation of BSpline'] .
! !

!BSpline methodsFor: 'rendering' stamp: 'CR 10/23/2012 14:11'!
render

	ShapeRenderer drawPolyLine: self tesselatedPoints.! !

!BSpline methodsFor: 'accessing' stamp: 'CR 10/21/2012 17:27'!
tesselatedPoints
	"Answer the value of tesselatedPoints"

	^ tesselatedPoints! !

!BSpline methodsFor: 'accessing' stamp: 'CR 10/21/2012 17:27'!
tesselatedPoints: anObject
	"Set the value of tesselatedPoints"

	tesselatedPoints := anObject! !

Object subclass: #ClickState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

ClickState subclass: #AddNodeClickState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!AddNodeClickState methodsFor: 'as yet unclassified' stamp: 'CR 12/25/2012 20:01'!
handleClick
	self halt.! !

!ClickState methodsFor: 'as yet unclassified' stamp: 'CR 12/25/2012 20:01'!
handleClick
	 ^ self subclassResponsibility.! !

Object subclass: #FirstClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 14:36'!
calculateLineWithP1: p1 p2: p2 p3: p3 p4: p4 div: divisions
	""
	| spline a0 a1 a2 a3 b0 b1 b2 b3 t |
	a0 := ((-1 * (p1 x)) + (p2 x * 3) - (3 * (p3 x)) + (p4 x)) / 6.
	a1 := ((3 * (p1 x)) - (6 * (p2 x)) + (3 * (p3 x))) / 6.
	a2 := ((-3 * (p1 x)) + (3 * (p3 x))) / 6.
	a3 := ((p1 x) + (4 * (p2 x)) + (p3 x)) / 6.
	b0 := ((-1 * (p1 y)) + (3 * (p2 y)) - (3 * (p3 y)) + (p4 y)) / 6.
	b1 := ((3 * (p1 y)) - (6 * (p2 y)) + (3 * (p3 y))) / 6.
	b2 := ((-3 * (p1 y)) + (3 * (p3 y))) / 6.
	b3 := ((p1 y) + (4 * (p2 y)) + (p3 y)) / 6.
	spline := OrderedCollection with: a3@b3.
	1 to: (divisions) do: [:i | 
		t := i / divisions.
		spline add:
			(a3 + (t * (a2 + (t * (a1 + (t * a0))))))
			@
			(b3 + (t * (b2 + (t * (b1 + (t * b0)))))).	
	].
	^spline.! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/18/2012 17:03'!
countBackwards: x
	"counts a given number backwards till zero"
	| temp |
	temp := x.
	[temp > 0] whileTrue: [
		temp := temp - 1.
		Transcript show: temp
	].! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/19/2012 14:00'!
drawACircleAt: aPoint
	"drawing a circle."
	| morph size |
	size := 20.
	morph := CircleMorph new.
	morph bounds: (Rectangle origin: (aPoint - ((size@size)/2)) extent: (size@size)).
	morph color: Color random.
	"morph setVertices: (OrderedCollection with: 100@100 with: 200@100 with: 100@200).
	morph color: (Color h: 40 s: 0.7 v: 0.6 alpha: 0.5).
	morph borderWidth: 5.
	morph borderColor:  (Color h: 170 s: 0.7 v: 0.6 alpha: 0.6).
	morph makeOpen."
	morph openInWorld.! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/19/2012 14:24'!
drawALineFrom: aPoint To: anotherPoint
	"drawing a circle."
	| morph |
	morph := LineMorph from: aPoint to: anotherPoint color: Color black width: 2.
	morph openInWorld.! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/19/2012 13:30'!
drawAPolyLine
	"showcase for drawing a polygon line."
	| morph |
	morph := PolygonMorph new.
	morph setVertices: (OrderedCollection with: 100@100 with: 200@100 with: 100@200).
	morph color: (Color h: 40 s: 0.7 v: 0.6 alpha: 0.5).
	morph borderWidth: 5.
	morph borderColor:  (Color h: 170 s: 0.7 v: 0.6 alpha: 0.6).
	morph makeOpen.
	morph openInWorld.! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 14:19'!
drawBSpline: hullPoints
	"showcase for drawing a bSpline using Matrix calculation."
	| morph bSplineMorph spline |
	morph := PolygonMorph new.
	morph setVertices: hullPoints.
	morph color: (Color h: 40 s: 0.7 v: 0.6 alpha: 0.5).
	morph borderWidth: 2.
	morph borderColor:  (Color h: 170 s: 0.7 v: 0.6 alpha: 0.6).
	morph makeOpen.
	morph openInWorld.
	
	spline := OrderedCollection new.
	-2 to: (hullPoints size) do: [ :i |
	spline addAllLast: (self calculateLineWithP1: 
		(hullPoints at: ((i max: 1) min: (hullPoints size)))
		p2: (hullPoints at: (((i + 1) max: 1) min: (hullPoints size)))
		p3: (hullPoints at: (((i + 2) max: 1) min: (hullPoints size)))
		p4: (hullPoints at: (((i + 3) max: 1) min: (hullPoints size))) 
		div: 10).		
	].

	bSplineMorph := PolygonMorph new.
	bSplineMorph setVertices: spline.
	bSplineMorph color: (Color h: 40 s: 0.7 v: 0.6 alpha: 0.5).
	bSplineMorph borderWidth: 2.
	bSplineMorph borderColor:  (Color h: 10 s: 1.0 v: 1.0 alpha: 1.0).
	bSplineMorph makeOpen.
	bSplineMorph openInWorld.
	
	! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/17/2012 15:57'!
firstMethod
	^self.! !

Object subclass: #GUI
	instanceVariableNames: 'systemWindow mainWindow rootNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!GUI methodsFor: 'drawing' stamp: 'CR 11/30/2012 14:07'!
addMorphToMainWindow: aMorph
	"add Morph to the mainWindow"
	"if the position is outside of the mainWindow it is set to the upper left corner"
	(((((aMorph position) x) < ((self upperLeftPointOfMainWindow) x) or:
	((aMorph position) y) < ((self upperLeftPointOfMainWindow) y)) or:
	((aMorph position) x) > ((self lowerRightPointOfMainWindow) x)) or:
	((aMorph position) y) > ((self lowerRightPointOfMainWindow) y)) ifTrue: [
		"the morph is left or above the mainWindow"
		aMorph position: self upperLeftPointOfMainWindow.].
	self mainWindow addMorph: aMorph.! !

!GUI methodsFor: 'initialize' stamp: 'CR 11/30/2012 13:46'!
buttonActionCreateMorph
	^[ | circleMorph |
		Transcript show: 'the button is pressed'; cr.
		self mainWindow removeAllMorphs.
		circleMorph := CircleMorph new.
		self addMorphToMainWindow: circleMorph.]! !

!GUI methodsFor: 'initialize' stamp: 'CR 11/30/2012 14:09'!
buttonActionCreateMorphAtTheCenter
	^[ | circleMorph |
		self mainWindow removeAllMorphs.
		circleMorph := CircleMorph new.
		circleMorph position: self getCenter.
		self addMorphToMainWindow: circleMorph.]! !

!GUI methodsFor: 'initialize' stamp: 'CR 12/1/2012 17:56'!
buttonActionCreateTree
	^[ | treeMorph |
		self mainWindow removeAllMorphs.
		treeMorph := TreeBuilder buildSymmetricTreeWithRelations.
		treeMorph calculateRootedTreeLayoutAtPoint: self getCenter nodeSize: 20 nodePadding: 10 layerDistance: 30.
		treeMorph label: 'src'.
		treeMorph drawWithLinesOn: self mainWindow.]! !

!GUI methodsFor: 'initialize' stamp: 'CR 11/30/2012 13:47'!
buttonActionRemoveMorph
	^[self mainWindow removeAllMorphs.]! !

!GUI methodsFor: 'accessing' stamp: 'CR 11/30/2012 14:20'!
getCenter
	"calculates the center of the mainWindow and returns the values as Point"
	| x y |
	x := (self lowerRightPointOfMainWindow) x - (self upperLeftPointOfMainWindow) x.
	x := x/2.
	x := (self upperLeftPointOfMainWindow) x + x.
	y := (self lowerRightPointOfMainWindow) y - (self upperLeftPointOfMainWindow) y.
	y := y/2.
	y := (self upperLeftPointOfMainWindow) y + y.
	^x@y! !

!GUI methodsFor: 'initialize' stamp: 'CR 12/25/2012 20:04'!
initialize
	self systemWindow: PluggableSystemWindow new.
	self mainWindow: GUIMainWindow new.
	self mainWindow initializeState.
	
	self systemWindow
		label: 'Hierarchical Edge Bundles Demo';
		addMorph: mainWindow frame: (0@0.105 corner: 1@1).
	
	self initializeButtons.
	self systemWindow openInWorld.! !

!GUI methodsFor: 'initialize' stamp: 'CR 12/1/2012 17:59'!
initializeButtonWithAction: aBlock
	| aButton |
	aButton := PluggableButtonMorphPlus
		on: aBlock
		getState: nil
		action: #value.
	^aButton.! !

!GUI methodsFor: 'initialize' stamp: 'CR 12/1/2012 17:39'!
initializeButtons
	| buttonForStart buttonForReset buttonForCenteredMorph buttonForTree numberOfButtons |
	numberOfButtons := 4.
	
	buttonForStart := self initializeButtonWithAction: self buttonActionCreateMorph.
	buttonForStart label: 'show morph'.
	buttonForReset := self initializeButtonWithAction: self buttonActionRemoveMorph.
	buttonForReset label: 'remove first morph'.
	buttonForCenteredMorph := self initializeButtonWithAction: self buttonActionCreateMorphAtTheCenter.
	buttonForCenteredMorph label: 'show morph at the center'.
	buttonForTree := self initializeButtonWithAction: self buttonActionCreateTree.
	buttonForTree label: 'show tree'.
	
	self systemWindow addMorph: buttonForStart frame: (0@0 corner: (1/numberOfButtons  - 0.001)@0.1).
	self systemWindow addMorph: buttonForCenteredMorph frame: ((1/numberOfButtons  + 0.001)@0 corner: (2/numberOfButtons  - 0.001)@0.1).
	self systemWindow addMorph: buttonForReset frame: ((2/numberOfButtons  + 0.001)@0 corner: (3/numberOfButtons  - 0.001)@0.1).
	self systemWindow addMorph: buttonForTree frame: ((3/numberOfButtons  + 0.001)@0 corner: 1@0.1).! !

!GUI methodsFor: 'accessing' stamp: 'CR 11/9/2012 11:55'!
lowerRightPointOfMainWindow
	^self mainWindow bounds corner.! !

!GUI methodsFor: 'accessing' stamp: 'CR 11/9/2012 11:45'!
mainWindow
	"Answer the value of mainWindow"

	^ mainWindow! !

!GUI methodsFor: 'accessing' stamp: 'CR 11/9/2012 11:45'!
mainWindow: anObject
	"Set the value of mainWindow"

	mainWindow := anObject! !

!GUI methodsFor: 'accessing' stamp: 'CR 11/6/2012 18:12'!
systemWindow
	"Answer the value of systemWindow"

	^ systemWindow! !

!GUI methodsFor: 'accessing' stamp: 'CR 11/6/2012 18:12'!
systemWindow: anObject
	"Set the value of systemWindow"

	systemWindow := anObject! !

!GUI methodsFor: 'accessing' stamp: 'CR 11/9/2012 11:54'!
upperLeftPointOfMainWindow
	^self mainWindow bounds origin.! !

Object subclass: #Node
	instanceVariableNames: 'children parent relations weight x y size nodeRepresentation lineRepresentations label labelRepresentation transparency isHighlighted highlightedHierarchicalLines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!Node commentStamp: 'CR 10/19/2012 10:33' prior: 0!
A Node is a part of a graph data structure. It knows its parent and its children as well of all relations that connect the node to an other node.

Instance Variables
	children:		<Object>
	parent:		<Object>
	relations:		<Object>

children
	- xxxxx

parent
	- xxxxx

relations
	- xxxxx
!

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 13:59'!
abandonAll
	"recursively dispose all morph objects for this graph"
	self children do: [ :child |
		child abandonAll.
	].
	ShapeRenderer abandonNode: self.
	ShapeRenderer abandonHierarchicalLinesFor: self.
	self relations do: [:relation | relation abandon.].
	^self.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:11'!
addChild: aChild
	children add: aChild.
	aChild parent: self.! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:29'!
addRelation: aRelation
	relations add: aRelation.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 10/22/2012 15:40'!
calculateNumberOfLeafs
	"calculate the number of leaf nodes in this (sub-)tree."
	| numberOfLeafs |
	numberOfLeafs := 0.
	self children
		ifEmpty: [numberOfLeafs := 1]
		ifNotEmpty: [self children do: [ :child | numberOfLeafs := numberOfLeafs + child calculateNumberOfLeafs]].
	^numberOfLeafs! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 11/18/2012 15:07'!
calculatePathTo: otherNode useLCA: includeLCA
	| path myParent otherParent myList otherList |
	myParent := self.
	otherParent := otherNode.
	myList := OrderedCollection new.
	otherList := OrderedCollection new.

	"bring nodes to same depth"
	((myParent depth) > (otherParent depth)) ifTrue: [
		((myParent depth) - (otherParent depth)) timesRepeat: [
			myList add: myParent.
			myParent := myParent parent.
		].
	].
	((myParent depth) < (otherParent depth)) ifTrue: [
		((otherParent depth) - (myParent depth)) timesRepeat: [
			otherList add: otherParent .
			otherParent := otherParent parent.
		].
	].

	"go up one level of depth until parents are the same"
	[myParent ~~ otherParent]
	whileTrue: 
	[
		myList add: myParent.
		otherList add: otherParent .
		myParent := myParent parent.
		otherParent := otherParent parent.
	] 
	.
	(includeLCA | ((myList size + otherList size) < 3)) ifTrue: [
		myList add: myParent.
	].

	path := myList.
	path addAllLast: (otherList reversed).
	^path.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 09:57'!
calculateRadialTreeLayoutAtPoint: rootPoint nodeSize: nodeSize nodePadding: nodePadding layerDistance: layerDistance
	"."
	self 
		calculateRadialTreeLayoutAtPoint: rootPoint 
		startAngle: 0 
		endAngle: 2 * 3.1415
		nodeSize: nodeSize 
		nodePadding: nodePadding 
		layerDistance: layerDistance 
		totalNumberOfLeafs: (self calculateNumberOfLeafs).
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 10:01'!
calculateRadialTreeLayoutAtPoint: rootPoint startAngle: startAngle endAngle: endAngle nodeSize: nodeSize nodePadding: nodePadding layerDistance: layerDistance totalNumberOfLeafs: totalNumberOfLeafs
	"."
	| abc angle anglePerLeaf childStartAngle childEndAngle |
	angle := (startAngle + endAngle) / 2.
	self x: angle sin * (self depth - 1) * layerDistance + rootPoint x.
	self y: angle cos * (self depth - 1) * layerDistance + rootPoint y.
	self size: nodeSize.
	
	anglePerLeaf := (endAngle - startAngle) / totalNumberOfLeafs.
	childStartAngle := startAngle.
	self children do: [ :child | 
		abc := 0.
		childEndAngle := childStartAngle + (anglePerLeaf * (child calculateNumberOfLeafs)).
		child 
			calculateRadialTreeLayoutAtPoint: rootPoint 
			startAngle: childStartAngle
			endAngle: childEndAngle
			nodeSize: nodeSize
			nodePadding: nodePadding 
			layerDistance: layerDistance 
			totalNumberOfLeafs: (child calculateNumberOfLeafs).
		childStartAngle := childEndAngle.
	].
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 10/22/2012 15:46'!
calculateRootedTreeLayoutAtPoint: rootPoint nodeSize: nodeSize nodePadding: nodePadding layerDistance: layerDistance
	"."
	| childLeft length childX childY |
	self x: rootPoint x.
	self y: rootPoint y.
	self size: nodeSize.

	length := (nodeSize + nodePadding) * self calculateNumberOfLeafs.
	childLeft := rootPoint x - (length / 2).
	
	childX := childLeft.
	childY := rootPoint y + layerDistance.
	
	self children do: [ :child | 
		childX := childX + ((nodeSize + nodePadding) * child calculateNumberOfLeafs /2).
		child calculateRootedTreeLayoutAtPoint: (childX@childY) 
			nodeSize: nodeSize 
			nodePadding: nodePadding 
			layerDistance: layerDistance.
		childX := childX + ((nodeSize + nodePadding) * child calculateNumberOfLeafs /2).
	].
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 10/21/2012 16:12'!
calculateWeight
	"calculate the weight of this node depending on the weight of the children"

	| calculatedWeight |
	calculatedWeight := 0.
	self children
		ifEmpty: [calculatedWeight := self weight]
		ifNotEmpty: [self children do: [ :child | calculatedWeight := calculatedWeight + child calculateWeight]].
	self weight: calculatedWeight.
	^calculatedWeight! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:24'!
children
	^children! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
children: anObject
	"Set the value of children"

	children := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:37'!
depth
	self isRoot
		ifTrue: [^1]
		ifFalse: [^1 + parent depth].! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 11/30/2012 19:27'!
do: aBlock
	"recursively applies the given block"
	aBlock value: self.
	self children do: [ :child |
		child do: aBlock.
	].
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 14:05'!
drawHierarchyLinesOn: aMorph
	"recursively draws all parent-child-relations in its subtree as circles"
	self children do: [ :child |
		child drawHierarchyLinesOn: aMorph.
	].
	ShapeRenderer drawHierarchyLinesFor: self On: aMorph.
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 13:21'!
drawNodesOn: aMorph
	"recursively draws all nodes in its subtree as circles"
	self children do: [ :child |
		child drawNodesOn: aMorph.
	].	
	ShapeRenderer drawNode: self On: aMorph.
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 11/18/2012 14:45'!
drawRelationsOn: aMorph
	"recursively draws all relations in its subtree as circles"
	self relations do: [ :relation |
		relation
			calculateCurveForPath: (self calculatePathTo: (relation destination) useLCA: relation useLCA);
			drawOn: aMorph.
	].
	self children do: [ :child |
		child drawRelationsOn: aMorph.
	].
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 11/18/2012 14:37'!
drawWithLinesOn: aMorph
	"."
	self drawRelationsOn: aMorph;
		drawHierarchyLinesOn: aMorph;
		drawNodesOn: aMorph.
	^self.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:59'!
getMaxDepth
	"get depth of the whole (sub-)tree."
	| maxDepthOfChildren |
	maxDepthOfChildren := children inject: 0 into: [:prev :child | (prev > child getMaxDepth)
		ifTrue: [prev]
		ifFalse: [child getMaxDepth]].
	^ maxDepthOfChildren + 1.
! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 15:45'!
highlightHierarchyLineTo: aNode
	"highlights the line between self and the parent node"
	(self children includes: aNode) ifTrue: [
		self highlightedHierarchicalLines add: aNode.
	] ifFalse: [
		aNode highlightHierarchyLineTo: self.
	].
! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 15:22'!
highlightPathTo: aNode
	"highlights all nodes and hierarchical relations to aNode"
	| nodePath |
	nodePath := self calculatePathTo: aNode useLCA: true.
	2 to: (nodePath size) do: [ :i | (nodePath at: (i-1)) highlightHierarchyLineTo: (nodePath at: i). ].
	nodePath do: [:node | node isHighlighted: true. ].! !

!Node methodsFor: 'accessing' stamp: 'SL 12/24/2012 15:07'!
highlightedHierarchicalLines
	"Answer the value of highlightedHierarchicalLines"

	^ highlightedHierarchicalLines! !

!Node methodsFor: 'accessing' stamp: 'SL 12/24/2012 15:07'!
highlightedHierarchicalLines: anObject
	"Set the value of highlightedHierarchicalLines"

	highlightedHierarchicalLines := anObject! !

!Node methodsFor: 'initializing' stamp: 'SL 12/24/2012 15:27'!
initialize
	super initialize.
	weight := 1.
	isHighlighted := false.
	children := OrderedCollection new.
	relations := OrderedCollection new.
	lineRepresentations := Dictionary new.
	highlightedHierarchicalLines := OrderedCollection new.! !

!Node methodsFor: 'accessing' stamp: 'SL 12/24/2012 15:07'!
isHighlighted
	"Answer the value of isHighlighted"

	^ isHighlighted! !

!Node methodsFor: 'accessing' stamp: 'SL 12/24/2012 15:07'!
isHighlighted: anObject
	"Set the value of isHighlighted"

	isHighlighted := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:26'!
isLeaf
	^ children isEmpty.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:07'!
isRoot
	^ parent isNil.! !

!Node methodsFor: 'accessing' stamp: 'SL 11/30/2012 20:46'!
label
	"Answer the value of label"

	^ label! !

!Node methodsFor: 'accessing' stamp: 'SL 11/30/2012 20:46'!
label: anObject
	"Set the value of label"

	label := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 11/30/2012 20:46'!
labelRepresentation
	"Answer the value of labelRepresentation"

	^ labelRepresentation! !

!Node methodsFor: 'accessing' stamp: 'SL 11/30/2012 20:46'!
labelRepresentation: anObject
	"Set the value of labelRepresentation"

	labelRepresentation := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 17:36'!
lineRepresentations
	"Answer the value of lineRepresentations"

	^ lineRepresentations! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 17:36'!
lineRepresentations: anObject
	"Set the value of lineRepresentations"

	lineRepresentations := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 11/9/2012 11:40'!
nodeRepresentation
	"Answer the value of nodeRepresentation"

	^ nodeRepresentation! !

!Node methodsFor: 'accessing' stamp: 'SL 11/9/2012 11:40'!
nodeRepresentation: anObject
	"Set the value of nodeRepresentation"

	nodeRepresentation := anObject! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:13'!
parent
	"Answer the value of parent"

	^ parent! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:14'!
parent: anObject
	"Set the value of parent"

	parent := anObject! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:30'!
relations
	^relations! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
relations: anObject
	"Set the value of relations"

	relations := anObject! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/1/2012 19:12'!
setTransparency: aTransparency
	"recursively set the given transparency for whole (sub-)tree"
	self do: [ :node |
		node transparency: aTransparency.
		node children do: [ :relation | relation transparency: aTransparency ].
	].
	^self.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 17:28'!
size
	^size! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 17:27'!
size: anObject
	"Set the value of size"

	size := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 12/1/2012 14:54'!
transparency
	"Answer the value of transparency"

	^ transparency! !

!Node methodsFor: 'accessing' stamp: 'SL 12/1/2012 14:54'!
transparency: anObject
	"Set the value of transparency"

	transparency := anObject! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 14:23'!
weight
	^weight! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 14:23'!
weight: aNumber
	weight := aNumber.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
x
	"Answer the value of x"

	^ x! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
x: anObject
	"Set the value of x"

	x := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
y
	"Answer the value of y"

	^ y! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
y: anObject
	"Set the value of y"

	y := anObject! !

Object subclass: #Relation
	instanceVariableNames: 'source destination tesselatedPoints t useLCA interpolateControlPoints interpolateCurvePoints representation transparency'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!Relation commentStamp: 'CR 10/19/2012 10:34' prior: 0!
A Relation describes an usally non hierarchical connection between two nodes.

Instance Variables
	destination:		<Object>
	source:		<Object>

destination
	- xxxxx

source
	- xxxxx
!

!Relation methodsFor: 'drawing' stamp: 'SL 12/25/2012 13:50'!
abandon
	ShapeRenderer abandonRelation: self.! !

!Relation methodsFor: 'drawing' stamp: 'CR 10/23/2012 15:24'!
calculateBSpline: hullPoints
	"showcase for drawing a bSpline using Matrix calculation."
	
	self tesselatedPoints: OrderedCollection new.
	-2 to: (hullPoints size) do: [ :i |
	self tesselatedPoints addAllLast: (self calculateLineWithP1: 
		(hullPoints at: ((i max: 1) min: (hullPoints size)))
		p2: (hullPoints at: (((i + 1) max: 1) min: (hullPoints size)))
		p3: (hullPoints at: (((i + 2) max: 1) min: (hullPoints size)))
		p4: (hullPoints at: (((i + 3) max: 1) min: (hullPoints size))) 
		div: 10).		
	].! !

!Relation methodsFor: 'drawing' stamp: 'SL 10/24/2012 14:31'!
calculateCurve: aPointList
	"calculates the tesselatedPoints from the given control points"
	| interpolatedControlPoints |
	tesselatedPoints := OrderedCollection new.
	(self interpolateControlPoints) 
		ifTrue: [	interpolatedControlPoints := (self interpolatePoints: aPointList).]
		ifFalse: [interpolatedControlPoints := aPointList.].
	(interpolatedControlPoints size = 3)
		ifTrue: [self calculateQuadraticBezier: interpolatedControlPoints.]
		ifFalse: [self calculateBSpline: interpolatedControlPoints].
	(self interpolateCurvePoints)
		ifTrue: [self tesselatedPoints: (self interpolatePoints: (self tesselatedPoints))].! !

!Relation methodsFor: 'drawing' stamp: 'SL 10/23/2012 16:33'!
calculateCurveForPath: aNodeList
	| pointList |
	"extracts points from given list of nodes"
	pointList := OrderedCollection new.
	aNodeList do: [ :node | 
		pointList add: (node x)@(node y).
	].
	self calculateCurve: pointList.
	^self.
! !

!Relation methodsFor: 'drawing' stamp: 'CR 10/23/2012 15:19'!
calculateLineWithP1: p1 p2: p2 p3: p3 p4: p4 div: divisions
	"matrix magic to compute bspline"
	| spline a0 a1 a2 a3 b0 b1 b2 b3 t |
	a0 := ((p1 x * -1) + (p2 x * 3) - (3 * (p3 x)) + (p4 x)) / 6.
	a1 := ((3 * (p1 x)) - (6 * (p2 x)) + (3 * (p3 x))) / 6.
	a2 := ((-3 * (p1 x)) + (3 * (p3 x))) / 6.
	a3 := ((p1 x) + (4 * (p2 x)) + (p3 x)) / 6.
	b0 := ((-1 * (p1 y)) + (3 * (p2 y)) - (3 * (p3 y)) + (p4 y)) / 6.
	b1 := ((3 * (p1 y)) - (6 * (p2 y)) + (3 * (p3 y))) / 6.
	b2 := ((-3 * (p1 y)) + (3 * (p3 y))) / 6.
	b3 := ((p1 y) + (4 * (p2 y)) + (p3 y)) / 6.
	spline := OrderedCollection with: a3@b3.
	1 to: (divisions) do: [:i | 
		t := i / divisions.
		spline add:
			(a3 + (t * (a2 + (t * (a1 + (t * a0))))))
			@
			(b3 + (t * (b2 + (t * (b1 + (t * b0)))))).	
	].
	^spline.! !

!Relation methodsFor: 'drawing' stamp: 'SL 10/24/2012 10:42'!
calculateQuadraticBezier: aPointList

	| bernstein0 bernstein1 bernstein2 calculatedPoint step amountOfSteps t|
	amountOfSteps := 10.
	self tesselatedPoints add: (aPointList at: 1).
	(aPointList size = 3) ifTrue: [
		step := 1 / (amountOfSteps - 1).
		2 to: (amountOfSteps - 1) do: [ :i |
			t := i * step.
			bernstein0 := (1 - t) * (1 - t).
			bernstein1 := 2 * t * (1 - t).
			bernstein2 := t * t.
			calculatedPoint := (aPointList at: 1) * bernstein0.
			calculatedPoint := calculatedPoint + ((aPointList at: 2) * bernstein1).
			calculatedPoint := calculatedPoint + ((aPointList at: 3) * bernstein2).
			self tesselatedPoints add: calculatedPoint.
		]].! !

!Relation methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:28'!
destination
	"Answer the value of destination"

	^ destination! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/24/2012 14:22'!
destination: anObject
	"Set the value of destination"

	destination := anObject! !

!Relation methodsFor: 'drawing' stamp: 'SL 12/24/2012 14:54'!
drawOn: aMorph
	ShapeRenderer drawRelation: self On: aMorph.
! !

!Relation methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 13:35'!
initialize
	super initialize.
	self t: 0.85.
	self useLCA: false.
	self interpolateCurvePoints: false.
	self interpolateControlPoints: true.
	self transparency: 1.0.! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/24/2012 14:27'!
interpolateControlPoints
	"Answer the value of interpolateControlPoints"

	^ interpolateControlPoints! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/24/2012 14:27'!
interpolateControlPoints: anObject
	"Set the value of interpolateControlPoints"

	interpolateControlPoints := anObject! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/24/2012 14:27'!
interpolateCurvePoints
	"Answer the value of interpolateCurvePoints"

	^ interpolateCurvePoints! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/24/2012 14:27'!
interpolateCurvePoints: anObject
	"Set the value of interpolateCurvePoints"

	interpolateCurvePoints := anObject! !

!Relation methodsFor: 'drawing' stamp: 'SL 12/1/2012 14:50'!
interpolatePoints: aPointList
	"interpolate given point list"
	| interpolatedList first last t |
	t := self t.
	first := aPointList first.
	last := aPointList last.
	interpolatedList := OrderedCollection with: first.
	2 to: (aPointList size - 1) do: [ :i |
		interpolatedList add:
			(((aPointList at: i) * t) + 
			((1 - t) * (first + (((i-1) / (aPointList size - 1)) * (last - first))))).
	].
	interpolatedList add: last.
	^interpolatedList.! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/1/2012 15:24'!
representation
	"Answer the value of representation"

	^ representation! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/1/2012 15:24'!
representation: anObject
	"Set the value of representation"

	representation := anObject! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/23/2012 15:47'!
setSource: sourceNode andDestination: destinationNode
	sourceNode addRelation: self.
	source := sourceNode.
	destination := destinationNode.
	^self.! !

!Relation methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:28'!
source
	"Answer the value of source"

	^ source! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/24/2012 14:22'!
source: anObject
	"Set the value of source"

	source := anObject! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/24/2012 14:22'!
t
	"Answer the value of t"

	^ t! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/24/2012 14:22'!
t: anObject
	"Set the value of t"

	t := anObject! !

!Relation methodsFor: 'accessing' stamp: 'CR 10/23/2012 15:02'!
tesselatedPoints
	"Answer the value of tesselatedPoints"

	^ tesselatedPoints! !

!Relation methodsFor: 'accessing' stamp: 'CR 10/23/2012 15:02'!
tesselatedPoints: anObject
	"Set the value of tesselatedPoints"

	tesselatedPoints := anObject! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/1/2012 15:24'!
transparency
	"Answer the value of transparency"

	^ transparency! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/1/2012 15:24'!
transparency: anObject
	"Set the value of transparency"

	transparency := anObject! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/24/2012 14:23'!
useLCA
	"Answer the value of useLCA"

	^ useLCA! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/24/2012 14:23'!
useLCA: anObject
	"Set the value of useLCA"

	useLCA := anObject! !

Object subclass: #RootedTreeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!RootedTreeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 10/21/2012 15:05'!
render: aNode
	"renders a tree"
	self render: aNode.
	^self! !

!RootedTreeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 10/21/2012 15:05'!
render: aNode At: aPoint
	^self! !

Object subclass: #ShapeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 14:01'!
abandonHierarchicalLinesFor: aNode

	aNode lineRepresentations do: [ :representation |
		representation abandon.
	].
	aNode lineRepresentations removeAll.! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 14:03'!
abandonLabelFor: aNode

	(aNode labelRepresentation) ifNotNil: [
		aNode labelRepresentation abandon.
	].

! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 14:03'!
abandonNode: aNode

	aNode nodeRepresentation ifNotNil: [
		aNode nodeRepresentation abandon.
		aNode nodeRepresentation: nil.
	].
	self abandonLabelFor: aNode.! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 13:51'!
abandonRelation: aRelation

	aRelation representation ifNotNil: [
		aRelation representation abandon.
		aRelation representation: nil.
	].! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 15:46'!
drawHierarchyLinesFor: aNode On: aMorph
	"draws a simple line"
	| lineRepresentation |	
	aNode children do: [ :child |
		"create circle morph, if not already done"
		(aNode lineRepresentations includesKey: child) ifFalse: [
			aNode lineRepresentations at: child put: (LineMorph
				from: (0)@(0)
				to: (0)@(0)
				color: Color darkGray
				width: 2).
				aMorph addMorph: (aNode lineRepresentations at: child).
		].

		"update lineMorph according to node attributes"
		lineRepresentation := (aNode lineRepresentations at: child).
		lineRepresentation 
			verticesAt: 1 put: ((aNode x)@(aNode y));
			verticesAt: 2 put: ((child x)@(child y)).
		"highlighting"
		(aNode highlightedHierarchicalLines includes: child) ifTrue: [
			lineRepresentation
				borderWidth: 3;
				borderColor: (Color blue darker).
		] ifFalse: [
			lineRepresentation
				borderWidth: 2;
				borderColor: Color darkGray.
		].

	].! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 13:54'!
drawLabelForNode: aNode
	"draws a text next to a cirlce morph"
	(aNode label) ifNotNil: [
		"create label morph, if not already done"
		aNode labelRepresentation ifNil: [
			aNode labelRepresentation: (StringMorph contents: aNode label).		
			aNode nodeRepresentation addMorph: aNode labelRepresentation.
		].
		"update label according to node attributes"
		(aNode labelRepresentation) position: (
			(aNode size / 2 + (aNode x)) @
			(aNode size / 2 + (aNode y))
		).
	].

! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'CR 12/25/2012 19:53'!
drawNode: aNode On: aMorph
	"create circle morph, if not already done"
	| nodeMorph |
	aNode nodeRepresentation ifNil: [
		nodeMorph := NodeMorph new.
		nodeMorph node: aNode.
		nodeMorph gui: aMorph.
		aNode nodeRepresentation: nodeMorph.
		aMorph addMorph: (aNode nodeRepresentation).
	].
	"update circle according to node attributes"
	self updateRepresentation: aNode nodeRepresentation forNode: aNode. 

	"draw the label for the node"
	self drawLabelForNode: aNode.! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/1/2012 20:28'!
drawPolyLine: aPointList

	| morph |
	morph := PolygonMorph new.
	morph setVertices: aPointList.
	morph borderWidth: 1.
	morph borderColor:  (Color h: 10 s: 1.0 v: 1.0 alpha: 1.0).
	morph makeOpen.
	^morph.! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 15:08'!
drawRelation: aRelation On: aMorph

	aRelation representation ifNil: [
		aRelation representation: PolygonMorph new.
		aMorph addMorph: aRelation representation.
		aRelation representation makeOpen.
	].

	aRelation representation setVertices: (aRelation tesselatedPoints).
	aRelation representation borderWidth: 1.
	aRelation representation borderColor:  (Color h: 10 s: 1.0 v: 1.0 alpha: aRelation transparency).
! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 15:47'!
updateRepresentation: aRepresentation forNode: aNode
	"size and position"
	aRepresentation bounds: (Rectangle
		origin: (((aNode x)@(aNode y)) - (((aNode size)@(aNode size))/2)) 
		extent: ((aNode size)@(aNode size))).
	"coloring"
	aRepresentation color: Color white.
	"highlighting"
	(aNode isHighlighted) ifTrue: [
		aRepresentation borderColor: (Color blue darker).
		aRepresentation borderWidth: 3.
	] ifFalse: [
		aRepresentation borderColor: Color darkGray.
		aRepresentation borderWidth: 1.
	].
	^aRepresentation.! !

Object subclass: #TreeBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 10/22/2012 18:05'!
buildLargeTree
	"creates a simple Treestructure"
	|			 				node1 
				node11 			       			node12 
	node111    node112    node113 		node121 		node122 
										      			node1221	node1222 |
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node112 := Node new.
	node113 := Node new.
	node12 := Node new.
	node121 := Node new.
	node122 := Node new.
	node1221 := Node new.
	node1222 := Node new.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	node11 addChild: node113.
	node11 addChild: Node new.
	node111 addChild: Node new.
	node111 addChild: Node new.
	node112 addChild: Node new.
	node112 addChild: Node new.
	node113 addChild: Node new.
	node113 addChild: Node new.
	node113 addChild: Node new.
	node1 addChild: node12.
	node12 addChild: node121.
	node12 addChild: node122.
	node122 addChild: node1221.
	node1221 addChild: Node new.
	node1221 addChild: Node new.
	node1221 addChild: Node new.
	node122 addChild: node1222.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	^node1.! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 10/24/2012 15:18'!
buildSymmetricTreeWithRelations
	"creates a simple Treestructure with relations"
	| nodeList relation |
	nodeList := OrderedCollection new.
	(1 + 4 + 16) timesRepeat: [nodeList add: Node new.].
	2 to: 5 do: [ :i |
		(nodeList at: 1) addChild: (nodeList at: i)
	].
	1 to: 4 do: [ :i |
		1 to: 4 do: [ :j |
			(nodeList at: i + 1) addChild: (nodeList at: (4 * i + j + 1))
		].
	].
	6 to: 21 do: [ :i |
		6 to: 21 do: [ :j |
			(j ~= i) ifTrue: [
				relation := Relation new
					setSource: (nodeList at: i)
					andDestination: (nodeList at: j).
			].
		].
	].
	
	^(nodeList at: 1).! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 10:06'!
buildTestTree
	"creates a simple Treestructure"
	|			 				node1 
				node11 			       			node12 
	node111       node112 		node113 		node121 		node122
										      			node1221	node1222 |
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node112 := Node new.
	node113 := Node new.
	node12 := Node new.
	node121 := Node new.
	node122 := Node new.
	node1221 := Node new.
	node1222 := Node new.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	node11 addChild: node113.
	node1 addChild: node12.
	node12 addChild: node121.
	node12 addChild: node122.
	node122 addChild: node1221.
	node122 addChild: node1222.
	^node1.! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 13:16'!
buildTreeForInterpolation
	"creates a simple Treestructure with a single relation"
	|			 				node1 
				node11 		node12 node13 node14			node15 
	node111    node112 						 			node151 		node152 
							 							node1511	node1512 

	relation112to1511
	|
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node112 := Node new.
	node12 := Node new.
	node13 := Node new.
	node14 := Node new.
	node15 := Node new.
	node151 := Node new.
	node152 := Node new.
	node1511 := Node new.
	node1512 := Node new.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	
	node1 addChild: node12.
	node1 addChild: node13.
	node1 addChild: node14.
	
	node1 addChild: node15.
	node15 addChild: node151.
	node15 addChild: node152.
	node151 addChild: node1511.
	node151 addChild: node1512.
	
	relation112to1511 := Relation new.
	relation112to1511 setSource: node112 andDestination: node1511.

	^node1.! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 13:34'!
buildTreeWithOverlyingRelations
	"creates an x-shaped Treestructure with 3 relations"
	|			 				node1 
			node11 						node12 
	node111    	node112 			node121 		node122

	relation111to121
	relation111to122
	relation112to121
	|
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node111 label: 'A'.
	node112 := Node new.
	node112 label: 'B'.
	node12 := Node new.
	node121 := Node new.
	node121 label: 'C'.
	node122 := Node new.
	node122 label: 'D'.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	
	node1 addChild: node12.
	node12 addChild: node121.
	node12 addChild: node122.
	
	relation111to122 := Relation new.
	relation111to122 setSource: node111 andDestination: node122.
	relation111to121 := Relation new.
	relation111to121 setSource: node111 andDestination: node121.
	relation112to121 := Relation new.
	relation112to121 setSource: node112 andDestination: node121.

	^node1.! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 16:52'!
buildTreeWithRelations
	"creates a simple Treestructure with relations"
	|			 				node1 
				node11 			       			node12 
	node111    node112    node113 		node121 		node122 
										      			node1221	node1222 

	relation111to112
	relation121to1222
	relation113to1221
	relation113to1222
	|
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node112 := Node new.
	node113 := Node new.
	node12 := Node new.
	node121 := Node new.
	node122 := Node new.
	node1221 := Node new.
	node1222 := Node new.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	node11 addChild: node113.
	node1 addChild: node12.
	node12 addChild: node121.
	node12 addChild: node122.
	node122 addChild: node1221.
	node122 addChild: node1222.
	
	relation111to112 := Relation new.
	relation111to112 setSource: node111 andDestination: node112.
	relation121to1222 := Relation new.
	relation121to1222 setSource: node121 andDestination: node1222.
	relation113to1221 := Relation new.
	relation113to1221 setSource: node113 andDestination: node1221.
	relation113to1222 := Relation new.
	relation113to1222 setSource: node113 andDestination: node1222.

	relation113to1222 := Relation new.

	^node1.! !
